<?php

namespace App\Policies;

use App\Models\RequestInfo;
use App\Models\User;
use Illuminate\Auth\Access\Response;

class RequestInfoPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->hasAnyPermission([
            'create requestinfo', 'edit requestinfo', 'view requestinfo', 'delete requestinfo'
        ]);
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, RequestInfo $requestInfo): bool
    {
        return $user->hasPermissionTo('view requestinfo');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasPermissionTo('create requestinfo');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, RequestInfo $requestInfo): bool
    {
        return $user->hasPermissionTo('edit requestinfo');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, RequestInfo $requestInfo): bool
    {
        return $user->hasPermissionTo('delete requestinfo');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, RequestInfo $requestInfo): bool
    {
        return $user->hasPermissionTo('restore requestinfo');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, RequestInfo $requestInfo): bool
    {
        return $user->hasPermissionTo('force delete requestinfo');
    }
}
